com.fasterxml.jackson.databind.ser.std

## Class DateTimeSerializerBase<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.std.StdScalarSerializer<T>
      - - com.fasterxml.jackson.databind.ser.std.DateTimeSerializerBase<T>

- All Implemented Interfaces:
    JsonFormatVisitable, SchemaAware, ContextualSerializer
  Direct Known Subclasses:
    CalendarSerializer, DateSerializer

      public abstract class DateTimeSerializerBase<T>
      extends StdScalarSerializer<T>
      implements ContextualSerializer

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `JsonSerializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected DateFormat` | `_customFormat` Specific format to use, if not default format: non null value also indicates that serialization is to be done as JSON String, not numeric timestamp, unless `_useTimestamp` is true.
    `protected boolean` | `_useTimestamp` Flag that indicates that serialization must be done as the Java timetamp, regardless of other settings.

    - ### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `_handledType`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `DateTimeSerializerBase(Class<T> type, boolean useTimestamp, DateFormat customFormat)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract long` | `_timestamp(T value)`
    `void` | `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
    `JsonSerializer<?>` | `createContextual(SerializerProvider prov, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
    `JsonNode` | `getSchema(SerializerProvider provider, Type typeHint)` Default implementation simply claims type is "string"; usually overriden by custom serializers.
    `boolean` | `isEmpty(T value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
    `abstract void` | `serialize(T value, JsonGenerator jgen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
    `abstract DateTimeSerializerBase<T>` | `withFormat(boolean timestamp, DateFormat customFormat)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdScalarSerializer

      `serializeWithType`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `createObjectNode, createSchemaNode, createSchemaNode, findConvertingContentSerializer, getSchema, handledType, isDefaultSerializer, wrapAndThrow, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `getDelegatee, isUnwrappingSerializer, replaceDelegatee, unwrappingSerializer, usesObjectId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _useTimestamp

          protected final boolean _useTimestamp

      Flag that indicates that serialization must be done as the Java timetamp, regardless of other settings.

    - #### _customFormat

          protected final DateFormat _customFormat

      Specific format to use, if not default format: non null value also indicates that serialization is to be done as JSON String, not numeric timestamp, unless `_useTimestamp` is true.

  - ### Constructor Detail

    - #### DateTimeSerializerBase

          protected DateTimeSerializerBase(Class<T> type,
                                boolean useTimestamp,
                                DateFormat customFormat)

  - ### Method Detail

    - #### withFormat

          public abstract DateTimeSerializerBase<T> withFormat(boolean timestamp,
                                             DateFormat customFormat)

    - #### createContextual

          public JsonSerializer<?> createContextual(SerializerProvider prov,
                                           BeanProperty property)
                                             throws JsonMappingException

      Description copied from interface: `ContextualSerializer`
      Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Specified by:
        `createContextual` in interface `ContextualSerializer`
      Parameters:
        `prov` - Serializer provider to use for accessing config, other serializers
        `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
      Returns:
        Serializer to use for serializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### isEmpty

          public boolean isEmpty(T value)

      Description copied from class: `JsonSerializer`
      Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

      Default implementation will consider only null values to be empty.

      Overrides:
        `isEmpty` in class `JsonSerializer<T>`

    - #### _timestamp

          protected abstract long _timestamp(T value)

    - #### getSchema

          public JsonNode getSchema(SerializerProvider provider,
                           Type typeHint)

      Description copied from class: `StdSerializer`
      Default implementation simply claims type is "string"; usually overriden by custom serializers.
      Specified by:
        `getSchema` in interface `SchemaAware`
      Overrides:
        `getSchema` in class `StdScalarSerializer<T>`
      Parameters:
        `provider` - The serializer provider.
        `typeHint` - A hint about the type.
      Returns:
        Json-schema for this serializer.

    - #### acceptJsonFormatVisitor

          public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                                     JavaType typeHint)
                                       throws JsonMappingException

      Description copied from class: `StdSerializer`
      Default implementation specifies no format. This behavior is usually overriden by custom serializers.
      Specified by:
        `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
      Overrides:
        `acceptJsonFormatVisitor` in class `StdScalarSerializer<T>`
        `typeHint` - Type of element (entity like property) being visited
      Throws:
        `JsonMappingException`

    - #### serialize

          public abstract void serialize(T value,
                       JsonGenerator jgen,
                       SerializerProvider provider)
                                  throws IOException,
                                         JsonGenerationException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles.
      Specified by:
        `serialize` in class `StdSerializer<T>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `jgen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
      Throws:
        `IOException`
        `JsonGenerationException`

Copyright © 2012-2013 FasterXML. All Rights Reserved.